﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        [DllImport("pdf2txt.dll", EntryPoint = "PDF2TXT", SetLastError = true,
           CharSet = CharSet.Ansi, ExactSpelling = true,
           CallingConvention = CallingConvention.StdCall)]
        public static extern int PDF2TXT(string pdfFileName, string txtFileName);

        [DllImport("pdf2txt.dll", EntryPoint = "PDF2TXTEx", SetLastError = true,
           CharSet = CharSet.Ansi, ExactSpelling = true,
           CallingConvention = CallingConvention.StdCall)]
        public static extern int PDF2TXTEx(string lpPDFName, string lpTXTName, int iFirstPage, int iLastPage, string ownerPWD, string userPWD);

        [DllImport("pdf2txt.dll", EntryPoint = "SetPageSeparator", SetLastError = true,
           CharSet = CharSet.Ansi, ExactSpelling = true,
           CallingConvention = CallingConvention.StdCall)]
        public static extern void SetPageSeparator(string pageSeparator);

        [DllImport("pdf2txt.dll", EntryPoint = "PDF2TXTSetLicenseCode", SetLastError = true,
           CharSet = CharSet.Ansi, ExactSpelling = true,
           CallingConvention = CallingConvention.StdCall)]
        public static extern void PDF2TXTSetLicenseCode(string strLicenseKey);

		/// <summary>
		/// Sets whether document summary should be added to the top of the page output text.
		/// </summary>
		/// <param name="isGetSummary">False won't add summary, true will add summary.</param>
		[DllImport("pdf2txt.dll", EntryPoint = "SetGetDocumentSummary", SetLastError = true,
			CharSet = CharSet.Ansi, ExactSpelling = true,
			CallingConvention = CallingConvention.StdCall)]
		public static extern void SetGetDocumentSummary(bool isGetSummary);

		/// <summary>
		/// Set whether the formatting should be kept in out output text.
		/// </summary>
		/// <param name="formatTXTFile">1 will keep formatting, 0 will not keep formatting.</param>
		/// <returns>Previous value of the setting.</returns>
		[DllImport("pdf2txt.dll", EntryPoint = "SetTXTFormat", SetLastError = true,
			CharSet = CharSet.Ansi, ExactSpelling = true,
			CallingConvention = CallingConvention.StdCall)]
		public static extern int SetTXTFormat(int formatTXTFile);

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PDF2TXTSetLicenseCode("XXXXXXXXXXXXXX");
            PDF2TXTEx("d:\\temp2\\temp.pdf", "C:\\out.txt", 0, 0, "", "");
        }
    }
}
