#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include "../pdf2txt.h"

void ConvertPDFFile2TextFile(char *pdffile, char *textfile)
{
	SetAutoSupportUnicode(FALSE);
	SetPageSeparator("Test for PageSeparator <<<<<<<<<********>>>>>>>>>>>>>");
	//SetPageSeparator("\f");
	SetZoomRatio(100);
	SetAutoAddSpace(FALSE);
	SetTXTFormat(TRUE);
	SetOpenResultFile(1);
	SetDeleteBlankLine(FALSE);

	if(0)
	{
		char szTempPath[MAX_PATH];
		strcpy(szTempPath,"C:\\");
		PDF2TextSetTempPath(MAX_PATH,szTempPath);
	}

	int iRet = PDF2TXT(pdffile,textfile);
}
int ConvertPDFFile2TextFileEx(char *pdffile, char *textfile)
{
	int iRet = PDF2TXTEx(pdffile, textfile,0,0,NULL,NULL);
	return iRet;
}
void ConvertPDFFile2TextBuffer(char *pdffile, char *textfile)
{
	SetPageSeparator("<<<<<<<<<********>>>>>>>>>>>>>");
	SetZoomRatio(100);
	SetTXTFormat(1);
	SetOpenResultFile(0);
	SetDeleteBlankLine(TRUE);
	
	int textBufferSize;
	const char *textbuffer = PDF2TextBuffer(pdffile,&textBufferSize);
	if(textbuffer)
		printf("%s\n",textbuffer);
	PDF2TextFreeBuffer(textbuffer);

	WCHAR wcPDFName[MAX_PATH];
	memset(wcPDFName,0,sizeof(WCHAR)*MAX_PATH);
	MultiByteToWideChar(CP_ACP,0,pdffile,strlen(pdffile),&wcPDFName[0],MAX_PATH);
	LPCWSTR textbuffer2 = PDF2TextBufferW(wcPDFName,&textBufferSize);
	PDF2TextFreeBufferW(textbuffer2);
	textbuffer2 = PDF2TextBufferWEx(pdffile,&textBufferSize, 0, 0, NULL, NULL, NULL, 0);
	PDF2TextFreeBufferW(textbuffer2);
}
void ConvertPDFBuffer2TextBuffer(char *pdffile, char *textfile)
{
	int nFileLength = 0;
	char* pdfBuffer = NULL;
  	FILE *file = fopen(pdffile,"rb");
	if(file)
	{
		nFileLength = _filelength(fileno(file));
		if(nFileLength <= 0)
		{
			fclose(file);
			return;
		}
		pdfBuffer = new char[nFileLength];
		if(pdfBuffer == NULL)
		{
			fclose(file);
			return;
		}
		memset(pdfBuffer,0,nFileLength);
		fread(pdfBuffer,1,nFileLength,file);
		fclose(file);
	}
	if(pdfBuffer == NULL || nFileLength <= 0)
		return;

	SetPageSeparator("<<<<<<<<<********>>>>>>>>>>>>>");
	SetZoomRatio(100);
	SetTXTFormat(1);
	SetOpenResultFile(0);
	SetDeleteBlankLine(TRUE);

	int textBufferSize;
	const char *textbuffer = PDFBuffer2TextBuffer(pdfBuffer,nFileLength,&textBufferSize);
	if(textbuffer)
		printf("%s\n",textbuffer);
	PDF2TextFreeBuffer(textbuffer);

	LPCWSTR textbufferW = PDFBuffer2TextBufferW(pdfBuffer,nFileLength,&textBufferSize);
	PDF2TextFreeBufferW(textbufferW);

	textbufferW = PDFBuffer2TextBufferWEx(pdfBuffer,nFileLength,&textBufferSize,0, 0,NULL,NULL,NULL,0);
	PDF2TextFreeBufferW(textbufferW);

	delete []pdfBuffer;
}
typedef struct PDF2TXTTHREADINFOtag{
	char szPDFName[MAX_PATH];
	int  dwThreadID;
	int  iResult;
}PDF2TXTTHREADINFO,*LPPDF2TXTTHREADINFO;
static DWORD WINAPI LaunchPDF2TXTThread(LPVOID pParam)
{
	LPPDF2TXTTHREADINFO lpPDF2TXTInfo = (LPPDF2TXTTHREADINFO)pParam;
	int iThreadID = GetCurrentThreadId();
	char szOutName[MAX_PATH];
	char szFileExt[MAX_PATH];
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[MAX_PATH],ext[_MAX_EXT];

	sprintf(szFileExt,"_%d",iThreadID);
	_splitpath(lpPDF2TXTInfo->szPDFName, drive, dir, fname, ext );
	strcat(fname,szFileExt);
	_makepath(szOutName, drive, dir, fname, ".txt");

	int result = PDF2TXT(lpPDF2TXTInfo->szPDFName,szOutName);
	printf("ThreadID = %d, OutName = %s, Result = %d\n",iThreadID,szOutName,result);
	return 0;
}
static DWORD WINAPI LaunchPDF2TXTExThread(LPVOID pParam)
{
	LPPDF2TXTTHREADINFO lpPDF2TXTInfo = (LPPDF2TXTTHREADINFO)pParam;
	int iThreadID = GetCurrentThreadId();
	char szOutName[MAX_PATH];
	char szFileExt[MAX_PATH];
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[MAX_PATH],ext[_MAX_EXT];

	sprintf(szFileExt,"_%d",iThreadID);
	_splitpath(lpPDF2TXTInfo->szPDFName, drive, dir, fname, ext );
	strcat(fname,szFileExt);
	_makepath(szOutName, drive, dir, fname, ".txt");

	int result = PDF2TXTEx(lpPDF2TXTInfo->szPDFName,szOutName,0,0,NULL,NULL);
	printf("ThreadID = %d, OutName = %s, Result = %d\n",iThreadID,szOutName,result);
	return 0;
}
void TestForMultiThread(char *szPDFName)
{
	for(int i = 0; i < 10; i++)
	{
		LPPDF2TXTTHREADINFO lpPDF2TXTInfo = new PDF2TXTTHREADINFO;
		strcpy(lpPDF2TXTInfo->szPDFName,szPDFName);
		
		HANDLE hThread;
		DWORD dwThreadId;
		hThread = CreateThread(NULL,0,LaunchPDF2TXTThread,lpPDF2TXTInfo,0,&dwThreadId);
		hThread = CreateThread(NULL,0,LaunchPDF2TXTExThread,lpPDF2TXTInfo,0,&dwThreadId);
	}
}
void main(int argc,char *argv[])
{
	if(argc != 3)
	{
		printf("Usage: input.pdf output.txt");
		return;
	}
	//Register your PDF2TXT SDK by given License Code
	PDF2TXTSetLicenseCode("XXXXXXXXXX");
	SetPasswords(NULL,NULL);

	CHAR szTXTName[MAX_PATH];
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],fname2[_MAX_FNAME],ext[_MAX_EXT];
	_splitpath(argv[2], drive, dir, fname, ext);

	sprintf(fname2,"%s-PDF2TXT",fname);
	_makepath(szTXTName, drive, dir,fname2,ext);
	int iBeginTick = GetTickCount();
	ConvertPDFFile2TextFile(argv[1],szTXTName);
	int iEndTick = GetTickCount();
	//printf("Time=%d\n",iEndTick-iBeginTick);

	sprintf(fname2,"%s-PDF2TXTEx",fname);
	_makepath(szTXTName, drive, dir,fname2,ext);
	int nRet = ConvertPDFFile2TextFileEx(argv[1],szTXTName);
	printf("PDF2TXTEx() return value = %d\n",nRet);
//	ShellExecuteA(NULL,"open",szTXTName,NULL,NULL,SW_SHOW);

	sprintf(fname2,"%s-PDF2TXTEx2",fname);
	_makepath(szTXTName, drive, dir,fname2,ext);
	nRet = PDF2TXTEx2(argv[1], szTXTName, 0, 0, NULL, NULL, "UTF-8", FALSE);
	printf("PDF2TXTEx2() return value = %d\n",nRet);

//	TestForMultiThread(argv[1]);
//	getchar();
	
	ConvertPDFFile2TextBuffer(argv[1],argv[2]);
	ConvertPDFBuffer2TextBuffer(argv[1],argv[2]);
	printf("Press any key to continue ...\n");
	getchar();

}//  LPSTR lpCmdLine,      // pointer to command line
//  int nCmdShow          // show state of window
